//  Problem mit Interrupt des Timer1 bei PIC18F2550


#include <18F4620.h>
#device adc=8
#use delay(clock=16000000, RESTART_WDT)
#fuses HS, NOPROTECT, NOPUT, BROWNOUT, NOLVP


#int_TIMER1
void TIMER1_isr()
{	// Bei 16 MHZ ist T = 62.5us
	// Um 200us zu bekommen muss T1_DIV_BY_4 wegen der 16MHZ Taktfrequenz umgestellt werden
	// Wegen der Interruptsetup Zeit muessen bei 16Mhz 12 Taktperioden abgezogne werden
	// Wie am Oszillogramm ersichtlich, muss man fuer 200us, T = 65348 einsetzen
	set_timer1(65335); //65535-200=65335
	OUTPUT_HIGH(PIN_B7);
	delay_cycles(10);	// ca. 3us @ 16 MHZ
	OUTPUT_LOW(PIN_B7);
	//delay_cycles(10);

}

void main()
{
	SET_TRIS_B( 0x00 ); //alle Pins von Port B sind Ausgang
	//setup_adc_ports(NO_ANALOGS|VSS_VDD);
	//setup_adc(ADC_OFF);
	//setup_spi(FALSE);
	//setup_wdt(WDT_OFF);
	//setup_timer_0(RTCC_OFF);
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_1);
	//setup_timer_2(T2_DISABLED,0,1);
	//setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
	//setup_comparator(NC_NC_NC_NC);
	//setup_vref(FALSE);
	enable_interrupts(INT_TIMER1);
	enable_interrupts(GLOBAL);

	for(;;)
	{
		OUTPUT_HIGH(PIN_B6);
		delay_cycles(100);
		OUTPUT_LOW(PIN_B6);
		delay_cycles(100);
	}

}


